#! /bin/bash
echo "Building library archives"
echo "Lookup environment ..."
version=`sed "s/^tclp__version('\([^']*\)'.*$/\1/" < src/tclp/version.pl`
local_dir=tclp-$version
tgz=tclp-prolog-$version.tgz
zip=tclp-prolog-$version.zip
echo "version: $version"
echo "archive names: $tgz $zip"
mkdir -p $local_dir/tclp
echo "Making doc ... "
(cd doc ; make)
echo "done"
echo "Archiving ... "
cp src/tclp/*.pl $local_dir/tclp
cp src/tclp.pl $local_dir/
for i in lib/* ; do
    if [ -d $i -a $i != lib/CVS ] 
    then tar cf - $i/*.typ  $i/*.pl | (cd $local_dir/tclp; tar xf -)
    fi
done
tar cf - COPYING LGPL CHANGELOG INSTALL-PROLOG | (cd $local_dir; tar xf -)
./cpdoc.sh $local_dir
tar cf - $local_dir | gzip -c > $tgz
rm -f $zip
zip -r $zip $local_dir
rm -rf $local_dir
echo "done"
